#ifdef OSR5
#pragma comment(exestr, "%Z% %M% %I% %E% %Q%")
#endif

#ifdef SOLARIS
#pragma ident	"%Z% %M% %I% %D% %Q% SMI"
#endif
/*
 * Copyright (C) 1996 Michael Davidson.
 * All rights reserved.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#include	<errno.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

extern char	emulator[];
int		quiet = 0;

/*
 * fatal(err, format, ...)	- print an error message and exit
 */
void
fatal(
    int		err,		/* system call error # or 0		*/
    char	*fmt,		/* message format string		*/
    ...				/* optional arguments			*/
    )
{
    va_list	args;

    va_start(args, fmt);
    (void) fprintf(stderr, "%s: fatal error: ",
		   (emulator[0] == '\0')  ?  "LXRUN" :  emulator );
    (void) vfprintf(stderr, fmt, args); 
    if (err > 0)
	(void) fprintf(stderr, ": %s\n", strerror(err));
    else
	(void) fprintf(stderr, "\n");
    va_end(args);

    exit(1);
}

/*
 * warning(err, format, ...)	- print a warning message
 */
void
warning(
    int		err,		/* system call error # or 0		*/
    char	*fmt,		/* message format string		*/
    ...				/* optional arguments			*/
    )
{
    va_list	args;

    va_start(args, fmt);
    if(!quiet) {
	    (void) fprintf(stderr, "%s: warning: ",
			   (emulator[0] == '\0')  ?  "LXRUN" :  emulator );
	    (void) vfprintf(stderr, fmt, args);
	    if (err > 0)
		(void) fprintf(stderr, ": %s\n", strerror(err));
	    else
		(void) fprintf(stderr, "\n");
    }
    va_end(args);
}
