#pragma ident "%Z%%M% %I%     %E% SMI"

#if !defined(LX_IPC_H)
#define LX_IPC_H

#include	"linux/types.h"

typedef int lx_key_t;
#define LX_IPC_PRIVATE ((lx_key_t) 0)  

struct lx_ipc_perm
{
	lx_key_t 	key;
	unsigned short	uid;   /* owner euid and egid */
	unsigned short	gid;
	unsigned short	cuid;  /* creator euid and egid */
	unsigned short	cgid;
	unsigned short	mode;  /* access modes see mode flags below */
	unsigned short	seq;   /* sequence number */
};


/* resource get request flags */
#define LX_IPC_CREAT  00001000   /* create if key is nonexistent */
#define LX_IPC_EXCL   00002000   /* fail if key exists */
#define LX_IPC_NOWAIT 00004000   /* return error on wait */


/* 
 * Control commands used with semctl, msgctl and shmctl 
 * see also specific commands in sem.h, msg.h and shm.h
 */
#define LX_IPC_RMID 0     /* remove resource */
#define LX_IPC_SET  1     /* set ipc_perm options */
#define LX_IPC_STAT 2     /* get ipc_perm options */
#define LX_IPC_INFO 3     /* see ipcs */

/* 
 * These are used to wrap system calls. See ipc/util.c.
 */
struct lx_ipc_kludge
{
    void	*ptr;
    int		type;
};

#define LX_SEMOP	 	1
#define LX_SEMGET 		2
#define LX_SEMCTL 		3
#define LX_MSGSND 		11
#define LX_MSGRCV 		12
#define LX_MSGGET 		13
#define LX_MSGCTL 		14
#define LX_SHMAT 		21
#define LX_SHMDT 		22
#define LX_SHMGET 		23
#define LX_SHMCTL 		24

#endif
