#pragma ident "@(#)msg.h      1.2     99/02/18 SMI"

#if !defined(LX_MSG_H)
#define LX_MSG_H

#include	"linux/ipc.h"

/* msgrcv options */
#define LX_MSG_NOERROR     010000  /* no error if message is too big */
#define LX_MSG_EXCEPT      020000  /* recv any msg except of specified type.*/

/* one msqid structure for each queue on the system */
struct lx_msqid_ds {
    struct lx_ipc_perm msg_perm;
    struct lx_msg *msg_first;  /* first message on queue */
    struct lx_msg *msg_last;   /* last message in queue */
    time_t msg_stime;       /* last msgsnd time */
    time_t msg_rtime;       /* last msgrcv time */
    time_t msg_ctime;       /* last change time */
    struct lx_wait_queue *wwait;
    struct lx_wait_queue *rwait;
    unsigned short msg_cbytes;      /* current number of bytes on queue */
    unsigned short msg_qnum;        /* number of messages in queue */
    unsigned short msg_qbytes;      /* max number of bytes on queue */
    unsigned short msg_lspid;       /* pid of last msgsnd */
    unsigned short msg_lrpid;       /* last receive pid */
};

/* message buffer for msgsnd and msgrcv calls */
struct lx_msgbuf {
    long mtype;         /* type of message */
    char mtext[1];      /* message text */
};

/* buffer for msgctl calls IPC_INFO, MSG_INFO */
struct lx_msginfo {
    int msgpool;
    int msgmap; 
    int msgmax; 
    int msgmnb; 
    int msgmni; 
    int msgssz; 
    int msgtql; 
    unsigned short  msgseg; 
};

/* one msg structure for each message */
struct lx_msg {
    struct lx_msg *msg_next;   /* next message on queue */
    long  msg_type;          
    char *msg_spot;         /* message text address */
    short msg_ts;           /* message text size */
};

/* ipcs ctl commands */
#define LX_MSG_STAT 11
#define LX_MSG_INFO 12

#endif
