#pragma ident "@(#)sem.h      1.2     99/02/18 SMI"

#if !defined(LX_SEM_H)
#define LX_SEM_H

#include	"linux/ipc.h"

/* semop flags */
#define LX_SEM_UNDO        0x1000  /* undo the operation on exit */

/* semctl Command Definitions. */
#define LX_GETPID  11       /* get sempid */
#define LX_GETVAL  12       /* get semval */
#define LX_GETALL  13       /* get all semval's */
#define LX_GETNCNT 14       /* get semncnt */
#define LX_GETZCNT 15       /* get semzcnt */
#define LX_SETVAL  16       /* set semval */
#define LX_SETALL  17       /* set all semval's */

/* One semid data structure for each set of semaphores in the system. */
struct lx_semid_ds {
  struct lx_ipc_perm sem_perm;            /* permissions .. see ipc.h */
  time_t          sem_otime;           /* last semop time */
  time_t          sem_ctime;           /* last change time */
  struct sem      *sem_base;           /* ptr to first semaphore in array */
  struct sem_queue *sem_pending;       /* pending operations to be processed */
  struct sem_queue **sem_pending_last; /* last pending operation */
  struct sem_undo *undo;	       /* undo requests on this array */
  unsigned short          sem_nsems;           /* no. of semaphores in array */
};

/* semop system calls takes an array of these. */
struct lx_sembuf {
  unsigned short  sem_num;        /* semaphore index in array */
  short   sem_op;         /* semaphore operation */
  short   sem_flg;        /* operation flags */
};

/* arg for semctl system calls. */
union lx_semun {
  int val;			/* value for SETVAL */
  struct lx_semid_ds *buf;		/* buffer for IPC_STAT & IPC_SET */
  unsigned short *array;		/* array for GETALL & SETALL */
  struct lx_seminfo *__buf;	/* buffer for IPC_INFO */
  void *__pad;
};

struct  lx_seminfo {
    int semmap;
    int semmni;
    int semmns;
    int semmnu;
    int semmsl;
    int semopm;
    int semume;
    int semusz;
    int semvmx;
    int semaem;
};

#endif
