#ifdef SOLARIS
#pragma ident	"%Z% %M% %I% %D% SMI"
#endif

#ifndef DISABLE_MAYMAP_REMAPPING
#define mmpath path
#endif

SYS(setup,		RET(int),	ARGS0()				)
SYS(exit,		RET(int),	ARGS1(int)			)
SYS(fork,		RET(int),	ARGS0()				)
SYS(read,		RET(int),	ARGS3(fd, buf_r, size)		)
SYS(write,		RET(int),	ARGS3(fd, buf_w, size)		)
SYS(open,		RET(int),	ARGS3(path, oflags, mode)	)
SYS(close,		RET(int),	ARGS1(fd)			)
SYS(waitpid,		RET(int),	ARGS3(pid, ptr, hex)		)
SYS(creat,		RET(int),	ARGS2(mmpath, mode)		)
SYS(link,		RET(int),	ARGS2(mmpath, mmpath)		)
SYS(unlink,		RET(int),	ARGS1(mmpath)			)
SYS(execve,		RET(int),	ARGS3(mmpath, argv, argv)	)
SYS(chdir,		RET(int),	ARGS1(mmpath)			)
SYS(time,		RET(int),	ARGS1(ptr)			)
SYS(mknod,		RET(int),	ARGS3(mmpath, mode, dev)	)
SYS(chmod,		RET(int),	ARGS2(mmpath, mode)		)
SYS(chown,		RET(int),	ARGS2(mmpath, uid)		)
SYS(break,		RET(int),	ARGS0()				)
SYS(oldstat,		RET(int),	ARGS2(path, old_stat)		)
SYS(lseek,		RET(int),	ARGS3(fd, off, int)		)
SYS(getpid,		RET(int),	ARGS0()				)
SYS(mount,		RET(int),	ARGS5(mmpath, mmpath, str, hex, ptr))
SYS(umount,		RET(int),	ARGS1(mmpath)			)
SYS(setuid,		RET(int),	ARGS1(uid)			)
SYS(getuid,		RET(int),	ARGS0()				)
SYS(stime,		RET(int),	ARGS1(ptr)			)
SYS(ptrace,		RET(int),	ARGS4(int, pid, hex, hex)	)
SYS(alarm,		RET(int),	ARGS1(int)			)
SYS(oldfstat,		RET(int),	ARGS2(fd, old_stat)		)
SYS(pause,		RET(int),	ARGS0()				)
SYS(utime,		RET(int),	ARGS2(mmpath, ptr)		)
SYS(stty,		RET(int),	ARGS0()				)
SYS(gtty,		RET(int),	ARGS0()				)
SYS(access,		RET(int),	ARGS2(path, amode)		)
SYS(nice,		RET(int),	ARGS1(int)			)
SYS(ftime,		RET(int),	ARGS0()				)
SYS(sync,		RET(int),	ARGS0()				)
SYS(kill,		RET(int),	ARGS2(pid, sig)			)
SYS(rename,		RET(int),	ARGS2(mmpath, mmpath)		)
SYS(mkdir,		RET(int),	ARGS2(path, mode)		)
SYS(rmdir,		RET(int),	ARGS1(path)			)
SYS(dup,		RET(int),	ARGS1(fd)			)
SYS(pipe,		RET(int),	ARGS1(pipefds)			)
SYS(times,		RET(int),	ARGS1(tms)			)
SYS(prof,		RET(int),	ARGS0()				)
SYS(brk,		RET(ptr),	ARGS1(ptr)			)
SYS(setgid,		RET(int),	ARGS1(int)			)
SYS(getgid,		RET(int),	ARGS0()				)
SYS(signal,		RET(int),	ARGS2(sig, ptr)			)
SYS(geteuid,		RET(int),	ARGS0()				)
SYS(getegid,		RET(int),	ARGS0()				)
SYS(acct,		RET(int),	ARGS0()				)
SYS(phys,		RET(int),	ARGS0()				)
SYS(lock,		RET(int),	ARGS0()				)
SYS(ioctl,		RET(int),	ARGS3(fd, hex, ptr)		)
SYS(fcntl,		RET(int),	ARGS3(fd, hex, ptr)		)
SYS(mpx,		RET(int),	ARGS0()				)
SYS(setpgid,		RET(int),	ARGS2(pid, pid)			)
SYS(ulimit,		RET(int),	ARGS0()				)
SYS(olduname,		RET(int),	ARGS1(ptr)			)
SYS(umask,		RET(int),	ARGS1(oct)			)
SYS(chroot,		RET(int),	ARGS1(mmpath)			)
SYS(ustat,		RET(int),	ARGS0()				)
SYS(dup2,		RET(int),	ARGS2(fd, int)			)
SYS(getppid,		RET(int),	ARGS0()				)
SYS(getpgrp,		RET(int),	ARGS0()				)
SYS(setsid,		RET(int),	ARGS0()				)
SYS(sigaction,		RET(int),	ARGS3(sig, sigact, sigact)	)
SYS(sgetmask,		RET(hex),	ARGS0()				)
SYS(ssetmask,		RET(int),	ARGS1(hex)			)
SYS(setreuid,		RET(int),	ARGS2(uid, uid)			)
SYS(setregid,		RET(int),	ARGS2(gid, gid)			)
SYS(sigsuspend,		RET(int),	ARGS3(int, hex, hex)		)
SYS(sigpending,		RET(int),	ARGS1(ptr)			)
SYS(sethostname,	RET(int),	ARGS2(str, int)			)
SYS(setrlimit,		RET(int),	ARGS2(res, rlim)		)
SYS(getrlimit,		RET(int),	ARGS2(res, rlim)		)
SYS(getrusage,		RET(int),	ARGS2(pid, rusage)		)
SYS(gettimeofday,	RET(int),	ARGS2(tv, tz)			)
SYS(settimeofday,	RET(int),	ARGS2(tv, tz)			)
SYS(getgroups,		RET(int),	ARGS2(int, ptr)			)
SYS(setgroups,		RET(int),	ARGS2(int, ptr)			)
SYS(old_select,		RET(int),	ARGS1(old_select)		)
SYS(symlink,		RET(int),	ARGS2(nmpath, mmpath)		)
SYS(oldlstat,		RET(int),	ARGS2(path, old_stat)		)
SYS(readlink,		RET(int),	ARGS3(mmpath, buf, size)	)
SYS(uselib,		RET(int),	ARGS1(path)			)
SYS(swapon,		RET(int),	ARGS1(mmpath)			)
SYS(reboot,		RET(int),	ARGS3(hex, int, hex)		)
SYS(readdir,		RET(int),	ARGS1(ptr)			)
SYS(mmap,		RET(ptr),	ARGS1(mmap)			)
SYS(munmap,		RET(int),	ARGS2(ptr, int)			)
SYS(truncate,		RET(int),	ARGS2(mmpath, off)		)
SYS(ftruncate,		RET(int),	ARGS2(fd, off)			)
SYS(fchmod,		RET(int),	ARGS2(fd, mode)			)
SYS(fchown,		RET(int),	ARGS3(fd, uid, gid)		)
SYS(getpriority,	RET(int),	ARGS2(int, int)			)
SYS(setpriority,	RET(int),	ARGS3(int, int, int)		)
SYS(profil,		RET(int),	ARGS0()				)
SYS(statfs,		RET(int),	ARGS2(mmpath, statfs)		)
SYS(fstatfs,		RET(int),	ARGS2(fd, statfs)		)
SYS(ioperm,		RET(int),	ARGS3(hex, hex, int)		)
SYS(socketcall,		RET(int),	ARGS1(socketcall)		)
SYS(syslog,		RET(int),	ARGS3(int, buf, size)		)
SYS(setitimer,		RET(int),	ARGS3(int, itv, itv)		)
SYS(getitimer,		RET(int),	ARGS2(int, itv)			)
SYS(stat,		RET(int),	ARGS2(path, stat)		)
SYS(lstat,		RET(int),	ARGS2(path, stat)		)
SYS(fstat,		RET(int),	ARGS2(int, stat)		)
SYS(uname,		RET(int),	ARGS1(ptr)			)
SYS(iopl,		RET(int),	ARGS1(hex)			)
SYS(vhangup,		RET(int),	ARGS0()				)
SYS(idle,		RET(int),	ARGS0()				)
SYS(vm86,		RET(int),	ARGS1(ptr)			)
SYS(wait4,		RET(int),	ARGS4(pid, ptr, hex, rusage)	)
SYS(swapoff,		RET(int),	ARGS1(mmpath)			)
SYS(sysinfo,		RET(int),	ARGS1(ptr)			)
SYS(ipc,		RET(int),	ARGS1(ipc)			)
SYS(fsync,		RET(int),	ARGS1(int)			)
SYS(sigreturn,		RET(int),	ARGS0()				)
SYS(clone,		RET(int),	ARGS2(ptr, hex)			)
SYS(setdomainname,	RET(int),	ARGS1(str)			)
SYS(newuname,		RET(int),	ARGS1(ptr)			)
SYS(modify_ldt,		RET(int),	ARGS0()				)
SYS(adjtimex,		RET(int),	ARGS0()				)
SYS(mprotect,		RET(int),	ARGS3(ptr, size, prot)		)
SYS(sigprocmask,	RET(int),	ARGS3(int, sigset, sigset)	)
SYS(create_module,	RET(int),	ARGS0()				)
SYS(init_module,	RET(int),	ARGS0()				)
SYS(delete_module,	RET(int),	ARGS0()				)
SYS(get_kernel_syms,	RET(int),	ARGS0()				)
SYS(quotactl,		RET(int),	ARGS4(int, mmpath, int, ptr)	)
SYS(getpgid,		RET(int),	ARGS1(pid)			)
SYS(fchdir,		RET(int),	ARGS1(fd)			)
SYS(bdflush,		RET(int),	ARGS0()				)
SYS(sysfs,		RET(int),	ARGS1(int)			)
SYS(personality,	RET(int),	ARGS1(int)			)
SYS(afs_syscall,	RET(int),	ARGS0()				)
SYS(setfsuid,		RET(int),	ARGS1(uid)			)
SYS(setfsgid,		RET(int),	ARGS1(gid)			)
SYS(_llseek,		RET(int),	ARGS5(fd, hex, hex, ptr, int)	)
SYS(getdents,		RET(int),	ARGS3(fd, ptr, int)		)
SYS(select,		RET(int),	ARGS5(int, fd_set, fd_set, fd_set, tv))
SYS(flock,		RET(int),	ARGS2(fd, int)			)
SYS(msync,		RET(int),	ARGS3(ptr, size, hex)		)
SYS(readv,		RET(int),	ARGS3(fd, iov_r, int)		)
SYS(writev,		RET(int),	ARGS3(fd, iov_w, int)		)
SYS(getsid,		RET(int),	ARGS1(pid)			)
SYS(fdatasync,		RET(int),	ARGS1(fd)			)
SYS(sysctl,		RET(int),	ARGS1(ptr)			)
SYS(mlock,		RET(int),	ARGS2(ptr, size)		)
SYS(munlock,		RET(int),	ARGS2(ptr, size)		)
SYS(mlockall,		RET(int),	ARGS1(hex)			)
SYS(munlockall,		RET(int),	ARGS0()				)
SYS(sched_setparam,	RET(int),	ARGS2(pid, sched_param)		)
SYS(sched_getparam,	RET(int),	ARGS2(pid, sched_param)		)
SYS(sched_setscheduler,	RET(int),	ARGS3(pid, int, ptr)		)
SYS(sched_getscheduler,	RET(int),	ARGS1(pid)			)
SYS(sched_yield,	RET(int),	ARGS0()				)
SYS(sched_get_priority_max,	RET(int),	ARGS1(int)		)
SYS(sched_get_priority_min,	RET(int),	ARGS1(int)		)
SYS(sched_rr_get_interval,	RET(int),	ARGS2(pid, ts)		)
SYS(nanosleep,		RET(int),	ARGS2(timespec, timespec)	)
SYS(mremap,		RET(ptr),	ARGS4(ptr, int, int, hex)	)
