#ifdef OSR5
#pragma comment(exestr, "%Z% %M% %I% %E% %Q%")
#endif

#ifdef SOLARIS
#pragma ident	"%Z%%M% %I% %D% SMI"
#endif
/*
 * Copyright (C) 1996-1997 Michael Davidson.
 * All rights reserved.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#include	<errno.h>
#include	"sysent.h"

/*
 * the following Linux system calls map directly onto the
 * corresponding system call in the native OS
 */

#define lx_exit		exit
#define lx_fork		fork
#define lx_creat	creat	
#define lx_link		link	
#define lx_unlink	unlink	
#define lx_chdir	chdir	
#define lx_time		time	
#define lx_mknod	mknod	
#define lx_chmod	chmod	
#define lx_chown	chown	
#define lx_lseek	lseek	
#define lx_getpid	getpid	
#define lx_setuid	setuid	
#define lx_getuid	getuid	
#define lx_stime	stime	
#define lx_alarm	alarm	
#define lx_pause	pause	
#define lx_utime	utime
#define lx_access	access
#define lx_nice		nice	
#define lx_sync		sync	
#define lx_rename	rename	
#define lx_mkdir	mkdir	
#define lx_rmdir	rmdir	
#define lx_dup		dup	
#define lx_times	times	
#define lx_setgid	setgid	
#define lx_getgid	getgid	
#define lx_geteuid	geteuid	
#define lx_getegid	getegid	
#define lx_setpgid	setpgid	
#define lx_umask	umask	
#define lx_chroot	chroot	
#define lx_dup2		dup2	
#define lx_getppid	getppid	
#define lx_getpgrp	getpgrp	
#define lx_setsid	setsid	
#define lx_setreuid	setreuid	
#define lx_setregid	setregid	
#define lx_sethostname	sethostname	
#define lx_gettimeofday	gettimeofday	
#define lx_settimeofday	settimeofday	
#define lx_symlink	symlink	
#define lx_readlink	readlink	
#define lx_truncate	truncate	
#define lx_ftruncate	ftruncate	
#define lx_fchmod	fchmod	
#define lx_fchown	fchown	
#ifndef UW7
#define lx_setitimer    setitimer
#define lx_getitimer    getitimer
#endif
#define lx_fsync	fsync	
#define lx_setdomainname	setdomainname	
#define lx_getpgid	getpgid	
#define lx_fchdir	fchdir	
#define lx_sysfs	sysfs	
#define lx_getdents	getdents	
#define lx_getsid	getsid
#if defined(SOLARIS)
#define lx_nanosleep	__nanosleep
#endif


/*
 * create the extern declarations for all of the system calls
 */
#undef SYS
#define SYS(scall, rtype, args)	extern int lx_##scall();
#include "syscalls.h"

/*
 * create the sysent table itself
 */
#undef SYS
#define	SYS(scall, rtype, args)	{ lx_##scall },

struct sysent sysent[] = {
#include	"syscalls.h"
};

int	nsysent = sizeof(sysent) / sizeof(sysent[0]);
