/* tioclinux.c - EXPERIMENTAL and UNFINISHED
 *
 * not built or enabled by default
 *  (activate EMULATE_TIOCLINUX in Makefile)
 *
 * Emulation of TIOCLINUX ioctl (some subcodes) for SCO OpenServer 5.0.x
 *
 * Copyright (c) 1998 Steven Ginzburg, all rights reserved.
 *
 * Sep  6 1998	- Initial revision
 *
 *
 * TIOCLINUX is the ioctl that gpm uses to do console cut+paste with the
 * mouse.  This code in lxrun is capable of the following:
 * 
 *  - highlighting portions of the console screen
 *  - reading the text off the console
 * 
 * on OpenServer5 
 * 
 * I could not find an analog to the "paste" (i.e., simulate typing on
 * the console) functionality in OpenServer.  
 * 
 * The code is untested on UnixWare and Solaris and may or may not do
 * anything useful at all so its ifdeffed for OSR5.
 * 
 * Commentary on inclusion :
 * My opinion is that the TIOCLINUX functionality is of very little
 * use to most apps.  If we could get an app like gpm working on a few
 * platforms, that would be great, and I would like to leave the emulation
 * in place.  If not, I won't feel heartbroken about removing it (or at
 * least, some of the more experimental subsets of it.)  Unfortunately,
 * I never reached this decision point because I hit the "not enough
 * information" wall I mentioned above.
 *      -- Steve
*/


#include <errno.h>
#include "lxrun.h"

#if defined(OSR5) && defined(EMULATE_TIOCLINUX)

#include <sys/console.h>
#include <string.h>
#include <stdlib.h>

extern int errno;

char sel_buffer[256];
int sel_count=0;

typedef struct region {
	short xs, ys, xe, ye;	/* Selection boundaries, 0-based */
	short sel_mode;		/* 0 = char, 1 = word, 2 = line */
} Region;


Region hilited;


void toggle_highlight(Region *r)
{
	int start, end, i;
	char *disp;			/* display memory */

	disp=(char *)ioctl(0, MAPCONS, 0L);

	if(r->sel_mode == 1)		/* word-based selection */
	{
	    /* Not implemented.  Default to char-based. */
	}
	else if(r->sel_mode == 2)	/* line-based selection */
	{
	    r->xs = 0; r->xe = 79;
	}

	start = r->xs*2 + 80*r->ys*2;
	end = r->xe*2 + 80*r->ye*2;

	/* Guarantee start <= end */
	if(start > end)
		start ^= end ^= start ^= end;

	sel_count = end-start;
	if(sel_count > sizeof sel_buffer)
		sel_count = sizeof sel_buffer;

	for(i=0; i<=sel_count && i<sizeof sel_buffer; ++i)
	{
	    disp[i+start+1] ^= 0x50;
	    sel_buffer[i] = disp[i+start];
	}
}


static int copyr(Region *r)
{
	/* unhighlight previous region */
	if(sel_count > 0)
		toggle_highlight(&hilited);

	memcpy(&hilited, r, sizeof(Region));

	toggle_highlight(&hilited);

	return 0;
}

int tioclinux(int fd, void *arg)
{
	switch(*((char *)arg))
	{
		case 2:		/* copy */
		{
			Region r;
			memcpy(&r, ((char *)arg)+1, sizeof(Region));
			--r.xs; --r.ys; --r.xe; --r.ye;

    		        return copyr(&r);
		}

		case 3:		/* paste */
			return write(fd, sel_buffer, sel_count);
			/*
			** This is not correct!  Is there a way to emulate
			** this properly on OpenServer?  I don't know...
			*/

		case 5:		/* define word boundaries */
			/* not implemented, but pretend it is */
			return 0;

		case 6:		/* get state of shift key */
			/* I don't know how to do this on OSR5.  So we'll   **
			** just tell the app that shift is not pressed.     */
			*(char *)arg = 0;
			return 0;

		default:
		    return enosys("unimpl handler for ioctl(TIOCLINUX)");
	}
}

#else

int
tioclinux(int fd, void *arg)
{
    return enoany(EINVAL, "unimplemented ioctl(TIOCLINUX)");
}
#endif  /* OSR5 && EMULATE_TIOCLINUX */


